/*
* Copyright(c) 1997-2001 Id Software, Inc.
* Copyright(c) Andrew Tridgell 1997-1998
* Copyright(c) 2002 The Quakeforge Project.
* Copyright(c) 2006 Quetoo.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or(at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
* 
* See the GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __MDFOUR_H__
#define __MDFOUR_H__

#if(SIZEOF_INT == 4)
# define int32 int
#elif(SIZEOF_LONG == 4)
# define int32 long
#elif(SIZEOF_SHORT == 4)
# define int32 short
#else 
# define int32 int
# define LARGE_INT32
#endif

#define uint32 unsigned int32

#define MDFOUR_DIGEST_BYTES 16

struct mdfour {
	uint32 A, B, C, D;
	uint32 totalN;
};

void mdfour_begin(struct mdfour *md);
void mdfour_update(struct mdfour *md, const unsigned char *in, int n);
void mdfour_result(struct mdfour *md, unsigned char *out);
void mdfour(unsigned char *out, const unsigned char *in, int n);

#endif /* __MDFOUR_H__ */
